/*
 * File: EmployeeClass.js
 * ----------------------
 * This file defines an Employee class and the HourlyEmployee subclass.
 * The definitions of CommissionedEmployee and SalariedEmployee are
 * left as exercises.
 */

/*
 * This class represents the superclass of the various categories of
 * employees.  It defines the methods that are common to all employees.
 */

function Employee(name, title) {
   return {
      getName: function() { return name; },
      getJobTitle: function() { return title; },
      getPay: function() { alert("getPay not defined for Employee class"); },
      toString: function() { return name + " (" + title + ")"; }
   };
}

/*
 * This subclass represents an hourly employee.
 */

function HourlyEmployee(name, title) {
   let emp = Employee(name, title);
   let hourlyRate = 0;
   let hoursWorked = 0;
   emp.setHourlyRate = function(wage) { hourlyRate = wage; };
   emp.setHoursWorked = function(hours) { hoursWorked = hours; };
   emp.getPay = function() { return hoursWorked * hourlyRate; };
   return emp;
}
