/*
 * File: Point.js
 * --------------
 * This file defines a simple class for representing points.
 */

/*
 * Creates a new Point object.  If this factory function is called with
 * no arguments, it creates a Point object at the origin.  The Point class
 * defines the getter methods getX and getY along with a toString method.
 */

function Point(x, y) {
   if (x === undefined) { x = 0; y = 0; }
   return {
      getX: function() { return x; },
      getY: function() { return y; },
      toString: function () { return "(" + x + ", " + y + ")"; }
   };
}
